package com.oreilly.jent.ejb.containerManaged;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import javax.naming.Context;
import javax.naming.InitialContext;

import com.oreilly.jent.ejb.Person;
import com.oreilly.jent.ejb.Profile;

public class PersonClient {
    public static void main(String[] args) {
        String fname = args[0];
        String lname = args[1];
        String fullName = fname + lname;
        
        try {
            // Get a JNDI context from our EJB server, using the 
            // properties in jndi.properties 
            Context context = new InitialContext();
            
            // Get the home interface for Person beans
            PersonHome pHome = (PersonHome)context.lookup("ejb/CMPPerson");
            
            // First, see if this person already exists
            System.out.println("Looking for " + fname + " " + lname);
            Person person = null;
            try {
                person = pHome.findByPrimaryKey(fullName);
            }
            catch (Exception e) {
                System.out.println("Exception while looking up person.");
            }
            
            if (person == null) {
                System.out.println("Creating person " + fullName);
                person = pHome.create(fullName, fname, lname);
            }
            
            // Get the person's profile
            Profile profile = person.getProfile();
            // Set some entries in the profile
            System.out.println("Setting profile entries for " + fullName);
            profile.setEntry("favoriteColor", "blue");
            profile.setEntry("language", "German");
            
            // Get the entries from the profile
            System.out.println("Getting profile entries for " + fullName);
            System.out.println("\tFavorite color: " +
                               profile.getEntry("favoriteColor"));
            System.out.println("\tLanguage: " + profile.getEntry("language"));
        }
        catch (Exception e) {
            System.out.println("Error while creating/using person");
            e.printStackTrace();
        }
    }
}
